#ifndef __BSP_IIC_H
#define __BSP_IIC_H
#include "stm32f10x.h"

/* I2CӵGPIO˿, ûֻҪ޸4д뼴ıSCLSDA */
#define GPIO_PORT_I2C	GPIOB			/* GPIO˿ */
#define RCC_I2C_PORT 	RCC_APB2Periph_GPIOB		/* GPIO˿ʱ */
#define I2C_SCL_PIN		GPIO_Pin_10			/* ӵSCLʱߵGPIO */
#define I2C_SDA_PIN		GPIO_Pin_11			/* ӵSDAߵGPIO */

/* дSCLSDAĺ꣬ӴĿֲԺͿĶ */
#if 1	/* 룺 1 ѡGPIOĿ⺯ʵIOд */
	#define I2C_SCL_1()  GPIO_SetBits(GPIO_PORT_I2C, I2C_SCL_PIN)		/* SCL = 1 */
	#define I2C_SCL_0()  GPIO_ResetBits(GPIO_PORT_I2C, I2C_SCL_PIN)		/* SCL = 0 */
	
	#define I2C_SDA_1()  GPIO_SetBits(GPIO_PORT_I2C, I2C_SDA_PIN)		/* SDA = 1 */
	#define I2C_SDA_0()  GPIO_ResetBits(GPIO_PORT_I2C, I2C_SDA_PIN)		/* SDA = 0 */
	
	#define I2C_SDA_READ()  GPIO_ReadInputDataBit(GPIO_PORT_I2C, I2C_SDA_PIN)	/* SDA״̬ */
#else	/* ֧ѡֱӼĴʵIOд */
    /*ע⣺дIAR߼ŻʱᱻŻ */
	#define I2C_SCL_1()  GPIO_PORT_I2C->BSRR = I2C_SCL_PIN				/* SCL = 1 */
	#define I2C_SCL_0()  GPIO_PORT_I2C->BRR = I2C_SCL_PIN				/* SCL = 0 */
	
	#define I2C_SDA_1()  GPIO_PORT_I2C->BSRR = I2C_SDA_PIN				/* SDA = 1 */
	#define I2C_SDA_0()  GPIO_PORT_I2C->BRR = I2C_SDA_PIN				/* SDA = 0 */
	
	#define I2C_SDA_READ()  ((GPIO_PORT_I2C->IDR & I2C_SDA_PIN) != 0)	/* SDA״̬ */
#endif


#include <inttypes.h>

#define I2C_WR	0		/* дbit */
#define I2C_RD	1		/* bit */

void i2c_Delay(void);
void IIC_Init(void);
void IIC_Start(void);
void IIC_Stop(void);
void IIC_Send_Byte(uint8_t _ucByte);
uint8_t IIC_Read_Byte(u8 ack);
uint8_t IIC_Wait_Ack(void);
void IIC_Ack(void);
void IIC_NAck(void);
uint8_t i2c_CheckDevice(uint8_t _Address);


#endif
















